# Avoid string type with unique identifiers

Convert a string or an int in an opaque type with a spice decoder.

### `string` identifier

```rescript
module DeliveryId = Toolkit.Identifier.MakeString();

/**
 somewhere
**/
@spice
type response = {
  deliveryId: DeliveryId.t
};

let deliveryId = DeliveryId.make("some-id");
deliveryId->DeliveryId.toString // "some-id"

let dict = DeliveryId.Dict.make()
dict->DeliveryId.Dict.set(deliveryId, "any")
```

### `int` identifier

```rescript
module DeliveryId = Toolkit.Identifier.MakeInt();

/**
 somewhere
**/
@spice
type response = {
  deliveryId: DeliveryId.t
};

let deliveryId = DeliveryId.make(12);
deliveryId->DeliveryId.toString; // "12"
deliveryId->DeliveryId.toInt; // 12
```
